<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayOfRouteMatrixInfo ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArrayOfRouteMatrixInfo
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfArrayOfRouteMatrixInfo extends AbstractStructArrayBase
{
    /**
     * The ArrayOfRouteMatrixInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo[]
     */
    public $ArrayOfRouteMatrixInfo;
    /**
     * Constructor method for ArrayOfArrayOfRouteMatrixInfo
     * @uses PcmArrayOfArrayOfRouteMatrixInfo::setArrayOfRouteMatrixInfo()
     * @param \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo[] $arrayOfRouteMatrixInfo
     */
    public function __construct(array $arrayOfRouteMatrixInfo = array())
    {
        $this
            ->setArrayOfRouteMatrixInfo($arrayOfRouteMatrixInfo);
    }
    /**
     * Get ArrayOfRouteMatrixInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo[]|null
     */
    public function getArrayOfRouteMatrixInfo()
    {
        return isset($this->ArrayOfRouteMatrixInfo) ? $this->ArrayOfRouteMatrixInfo : null;
    }
    /**
     * Set ArrayOfRouteMatrixInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo[] $arrayOfRouteMatrixInfo
     * @return \Pcm\ArrayType\PcmArrayOfArrayOfRouteMatrixInfo
     */
    public function setArrayOfRouteMatrixInfo(array $arrayOfRouteMatrixInfo = array())
    {
        foreach ($arrayOfRouteMatrixInfo as $arrayOfArrayOfRouteMatrixInfoArrayOfRouteMatrixInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayOfRouteMatrixInfoArrayOfRouteMatrixInfoItem instanceof \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo) {
                throw new \InvalidArgumentException(sprintf('The ArrayOfRouteMatrixInfo property can only contain items of \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo, "%s" given', is_object($arrayOfArrayOfRouteMatrixInfoArrayOfRouteMatrixInfoItem) ? get_class($arrayOfArrayOfRouteMatrixInfoArrayOfRouteMatrixInfoItem) : gettype($arrayOfArrayOfRouteMatrixInfoArrayOfRouteMatrixInfoItem)), __LINE__);
            }
        }
        if (is_null($arrayOfRouteMatrixInfo) || (is_array($arrayOfRouteMatrixInfo) && empty($arrayOfRouteMatrixInfo))) {
            unset($this->ArrayOfRouteMatrixInfo);
        } else {
            $this->ArrayOfRouteMatrixInfo = $arrayOfRouteMatrixInfo;
        }
        return $this;
    }
    /**
     * Add item to ArrayOfRouteMatrixInfo value
     * @throws \InvalidArgumentException
     * @param \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo $item
     * @return \Pcm\ArrayType\PcmArrayOfArrayOfRouteMatrixInfo
     */
    public function addToArrayOfRouteMatrixInfo(\Pcm\ArrayType\PcmArrayOfRouteMatrixInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfRouteMatrixInfo property can only contain items of \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArrayOfRouteMatrixInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\ArrayType\PcmArrayOfRouteMatrixInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfRouteMatrixInfo
     */
    public function getAttributeName()
    {
        return 'ArrayOfRouteMatrixInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfArrayOfRouteMatrixInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
