<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAvoidFavor ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAvoidFavor
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfAvoidFavor extends AbstractStructArrayBase
{
    /**
     * The AvoidFavor
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmAvoidFavor[]
     */
    public $AvoidFavor;
    /**
     * Constructor method for ArrayOfAvoidFavor
     * @uses PcmArrayOfAvoidFavor::setAvoidFavor()
     * @param \Pcm\StructType\PcmAvoidFavor[] $avoidFavor
     */
    public function __construct(array $avoidFavor = array())
    {
        $this
            ->setAvoidFavor($avoidFavor);
    }
    /**
     * Get AvoidFavor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmAvoidFavor[]|null
     */
    public function getAvoidFavor()
    {
        return isset($this->AvoidFavor) ? $this->AvoidFavor : null;
    }
    /**
     * Set AvoidFavor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmAvoidFavor[] $avoidFavor
     * @return \Pcm\ArrayType\PcmArrayOfAvoidFavor
     */
    public function setAvoidFavor(array $avoidFavor = array())
    {
        foreach ($avoidFavor as $arrayOfAvoidFavorAvoidFavorItem) {
            // validation for constraint: itemType
            if (!$arrayOfAvoidFavorAvoidFavorItem instanceof \Pcm\StructType\PcmAvoidFavor) {
                throw new \InvalidArgumentException(sprintf('The AvoidFavor property can only contain items of \Pcm\StructType\PcmAvoidFavor, "%s" given', is_object($arrayOfAvoidFavorAvoidFavorItem) ? get_class($arrayOfAvoidFavorAvoidFavorItem) : gettype($arrayOfAvoidFavorAvoidFavorItem)), __LINE__);
            }
        }
        if (is_null($avoidFavor) || (is_array($avoidFavor) && empty($avoidFavor))) {
            unset($this->AvoidFavor);
        } else {
            $this->AvoidFavor = $avoidFavor;
        }
        return $this;
    }
    /**
     * Add item to AvoidFavor value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmAvoidFavor $item
     * @return \Pcm\ArrayType\PcmArrayOfAvoidFavor
     */
    public function addToAvoidFavor(\Pcm\StructType\PcmAvoidFavor $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmAvoidFavor) {
            throw new \InvalidArgumentException(sprintf('The AvoidFavor property can only contain items of \Pcm\StructType\PcmAvoidFavor, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AvoidFavor[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmAvoidFavor|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmAvoidFavor|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmAvoidFavor|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmAvoidFavor|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmAvoidFavor|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AvoidFavor
     */
    public function getAttributeName()
    {
        return 'AvoidFavor';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfAvoidFavor
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
