<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDetailReportLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDetailReportLine
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfDetailReportLine extends AbstractStructArrayBase
{
    /**
     * The DetailReportLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmDetailReportLine[]
     */
    public $DetailReportLine;
    /**
     * Constructor method for ArrayOfDetailReportLine
     * @uses PcmArrayOfDetailReportLine::setDetailReportLine()
     * @param \Pcm\StructType\PcmDetailReportLine[] $detailReportLine
     */
    public function __construct(array $detailReportLine = array())
    {
        $this
            ->setDetailReportLine($detailReportLine);
    }
    /**
     * Get DetailReportLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmDetailReportLine[]|null
     */
    public function getDetailReportLine()
    {
        return isset($this->DetailReportLine) ? $this->DetailReportLine : null;
    }
    /**
     * Set DetailReportLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmDetailReportLine[] $detailReportLine
     * @return \Pcm\ArrayType\PcmArrayOfDetailReportLine
     */
    public function setDetailReportLine(array $detailReportLine = array())
    {
        foreach ($detailReportLine as $arrayOfDetailReportLineDetailReportLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfDetailReportLineDetailReportLineItem instanceof \Pcm\StructType\PcmDetailReportLine) {
                throw new \InvalidArgumentException(sprintf('The DetailReportLine property can only contain items of \Pcm\StructType\PcmDetailReportLine, "%s" given', is_object($arrayOfDetailReportLineDetailReportLineItem) ? get_class($arrayOfDetailReportLineDetailReportLineItem) : gettype($arrayOfDetailReportLineDetailReportLineItem)), __LINE__);
            }
        }
        if (is_null($detailReportLine) || (is_array($detailReportLine) && empty($detailReportLine))) {
            unset($this->DetailReportLine);
        } else {
            $this->DetailReportLine = $detailReportLine;
        }
        return $this;
    }
    /**
     * Add item to DetailReportLine value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmDetailReportLine $item
     * @return \Pcm\ArrayType\PcmArrayOfDetailReportLine
     */
    public function addToDetailReportLine(\Pcm\StructType\PcmDetailReportLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmDetailReportLine) {
            throw new \InvalidArgumentException(sprintf('The DetailReportLine property can only contain items of \Pcm\StructType\PcmDetailReportLine, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DetailReportLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmDetailReportLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmDetailReportLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmDetailReportLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmDetailReportLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmDetailReportLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DetailReportLine
     */
    public function getAttributeName()
    {
        return 'DetailReportLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfDetailReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
