<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDirectionsReportLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDirectionsReportLine
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfDirectionsReportLine extends AbstractStructArrayBase
{
    /**
     * The DirectionsReportLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmDirectionsReportLine[]
     */
    public $DirectionsReportLine;
    /**
     * Constructor method for ArrayOfDirectionsReportLine
     * @uses PcmArrayOfDirectionsReportLine::setDirectionsReportLine()
     * @param \Pcm\StructType\PcmDirectionsReportLine[] $directionsReportLine
     */
    public function __construct(array $directionsReportLine = array())
    {
        $this
            ->setDirectionsReportLine($directionsReportLine);
    }
    /**
     * Get DirectionsReportLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmDirectionsReportLine[]|null
     */
    public function getDirectionsReportLine()
    {
        return isset($this->DirectionsReportLine) ? $this->DirectionsReportLine : null;
    }
    /**
     * Set DirectionsReportLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmDirectionsReportLine[] $directionsReportLine
     * @return \Pcm\ArrayType\PcmArrayOfDirectionsReportLine
     */
    public function setDirectionsReportLine(array $directionsReportLine = array())
    {
        foreach ($directionsReportLine as $arrayOfDirectionsReportLineDirectionsReportLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfDirectionsReportLineDirectionsReportLineItem instanceof \Pcm\StructType\PcmDirectionsReportLine) {
                throw new \InvalidArgumentException(sprintf('The DirectionsReportLine property can only contain items of \Pcm\StructType\PcmDirectionsReportLine, "%s" given', is_object($arrayOfDirectionsReportLineDirectionsReportLineItem) ? get_class($arrayOfDirectionsReportLineDirectionsReportLineItem) : gettype($arrayOfDirectionsReportLineDirectionsReportLineItem)), __LINE__);
            }
        }
        if (is_null($directionsReportLine) || (is_array($directionsReportLine) && empty($directionsReportLine))) {
            unset($this->DirectionsReportLine);
        } else {
            $this->DirectionsReportLine = $directionsReportLine;
        }
        return $this;
    }
    /**
     * Add item to DirectionsReportLine value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmDirectionsReportLine $item
     * @return \Pcm\ArrayType\PcmArrayOfDirectionsReportLine
     */
    public function addToDirectionsReportLine(\Pcm\StructType\PcmDirectionsReportLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmDirectionsReportLine) {
            throw new \InvalidArgumentException(sprintf('The DirectionsReportLine property can only contain items of \Pcm\StructType\PcmDirectionsReportLine, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DirectionsReportLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmDirectionsReportLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmDirectionsReportLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmDirectionsReportLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmDirectionsReportLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmDirectionsReportLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DirectionsReportLine
     */
    public function getAttributeName()
    {
        return 'DirectionsReportLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfDirectionsReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
