<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFuelStopLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFuelStopLine
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfFuelStopLine extends AbstractStructArrayBase
{
    /**
     * The FuelStopLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmFuelStopLine[]
     */
    public $FuelStopLine;
    /**
     * Constructor method for ArrayOfFuelStopLine
     * @uses PcmArrayOfFuelStopLine::setFuelStopLine()
     * @param \Pcm\StructType\PcmFuelStopLine[] $fuelStopLine
     */
    public function __construct(array $fuelStopLine = array())
    {
        $this
            ->setFuelStopLine($fuelStopLine);
    }
    /**
     * Get FuelStopLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmFuelStopLine[]|null
     */
    public function getFuelStopLine()
    {
        return isset($this->FuelStopLine) ? $this->FuelStopLine : null;
    }
    /**
     * Set FuelStopLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmFuelStopLine[] $fuelStopLine
     * @return \Pcm\ArrayType\PcmArrayOfFuelStopLine
     */
    public function setFuelStopLine(array $fuelStopLine = array())
    {
        foreach ($fuelStopLine as $arrayOfFuelStopLineFuelStopLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfFuelStopLineFuelStopLineItem instanceof \Pcm\StructType\PcmFuelStopLine) {
                throw new \InvalidArgumentException(sprintf('The FuelStopLine property can only contain items of \Pcm\StructType\PcmFuelStopLine, "%s" given', is_object($arrayOfFuelStopLineFuelStopLineItem) ? get_class($arrayOfFuelStopLineFuelStopLineItem) : gettype($arrayOfFuelStopLineFuelStopLineItem)), __LINE__);
            }
        }
        if (is_null($fuelStopLine) || (is_array($fuelStopLine) && empty($fuelStopLine))) {
            unset($this->FuelStopLine);
        } else {
            $this->FuelStopLine = $fuelStopLine;
        }
        return $this;
    }
    /**
     * Add item to FuelStopLine value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmFuelStopLine $item
     * @return \Pcm\ArrayType\PcmArrayOfFuelStopLine
     */
    public function addToFuelStopLine(\Pcm\StructType\PcmFuelStopLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmFuelStopLine) {
            throw new \InvalidArgumentException(sprintf('The FuelStopLine property can only contain items of \Pcm\StructType\PcmFuelStopLine, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FuelStopLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmFuelStopLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmFuelStopLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmFuelStopLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmFuelStopLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmFuelStopLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FuelStopLine
     */
    public function getAttributeName()
    {
        return 'FuelStopLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfFuelStopLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
