<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPOIAlongRouteMatch ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPOIAlongRouteMatch
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfPOIAlongRouteMatch extends AbstractStructArrayBase
{
    /**
     * The POIAlongRouteMatch
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmPOIAlongRouteMatch[]
     */
    public $POIAlongRouteMatch;
    /**
     * Constructor method for ArrayOfPOIAlongRouteMatch
     * @uses PcmArrayOfPOIAlongRouteMatch::setPOIAlongRouteMatch()
     * @param \Pcm\StructType\PcmPOIAlongRouteMatch[] $pOIAlongRouteMatch
     */
    public function __construct(array $pOIAlongRouteMatch = array())
    {
        $this
            ->setPOIAlongRouteMatch($pOIAlongRouteMatch);
    }
    /**
     * Get POIAlongRouteMatch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch[]|null
     */
    public function getPOIAlongRouteMatch()
    {
        return isset($this->POIAlongRouteMatch) ? $this->POIAlongRouteMatch : null;
    }
    /**
     * Set POIAlongRouteMatch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmPOIAlongRouteMatch[] $pOIAlongRouteMatch
     * @return \Pcm\ArrayType\PcmArrayOfPOIAlongRouteMatch
     */
    public function setPOIAlongRouteMatch(array $pOIAlongRouteMatch = array())
    {
        foreach ($pOIAlongRouteMatch as $arrayOfPOIAlongRouteMatchPOIAlongRouteMatchItem) {
            // validation for constraint: itemType
            if (!$arrayOfPOIAlongRouteMatchPOIAlongRouteMatchItem instanceof \Pcm\StructType\PcmPOIAlongRouteMatch) {
                throw new \InvalidArgumentException(sprintf('The POIAlongRouteMatch property can only contain items of \Pcm\StructType\PcmPOIAlongRouteMatch, "%s" given', is_object($arrayOfPOIAlongRouteMatchPOIAlongRouteMatchItem) ? get_class($arrayOfPOIAlongRouteMatchPOIAlongRouteMatchItem) : gettype($arrayOfPOIAlongRouteMatchPOIAlongRouteMatchItem)), __LINE__);
            }
        }
        if (is_null($pOIAlongRouteMatch) || (is_array($pOIAlongRouteMatch) && empty($pOIAlongRouteMatch))) {
            unset($this->POIAlongRouteMatch);
        } else {
            $this->POIAlongRouteMatch = $pOIAlongRouteMatch;
        }
        return $this;
    }
    /**
     * Add item to POIAlongRouteMatch value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmPOIAlongRouteMatch $item
     * @return \Pcm\ArrayType\PcmArrayOfPOIAlongRouteMatch
     */
    public function addToPOIAlongRouteMatch(\Pcm\StructType\PcmPOIAlongRouteMatch $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmPOIAlongRouteMatch) {
            throw new \InvalidArgumentException(sprintf('The POIAlongRouteMatch property can only contain items of \Pcm\StructType\PcmPOIAlongRouteMatch, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->POIAlongRouteMatch[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmPOIAlongRouteMatch|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string POIAlongRouteMatch
     */
    public function getAttributeName()
    {
        return 'POIAlongRouteMatch';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfPOIAlongRouteMatch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
