<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRadiusSearchMatch ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRadiusSearchMatch
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfRadiusSearchMatch extends AbstractStructArrayBase
{
    /**
     * The RadiusSearchMatch
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmRadiusSearchMatch[]
     */
    public $RadiusSearchMatch;
    /**
     * Constructor method for ArrayOfRadiusSearchMatch
     * @uses PcmArrayOfRadiusSearchMatch::setRadiusSearchMatch()
     * @param \Pcm\StructType\PcmRadiusSearchMatch[] $radiusSearchMatch
     */
    public function __construct(array $radiusSearchMatch = array())
    {
        $this
            ->setRadiusSearchMatch($radiusSearchMatch);
    }
    /**
     * Get RadiusSearchMatch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmRadiusSearchMatch[]|null
     */
    public function getRadiusSearchMatch()
    {
        return isset($this->RadiusSearchMatch) ? $this->RadiusSearchMatch : null;
    }
    /**
     * Set RadiusSearchMatch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmRadiusSearchMatch[] $radiusSearchMatch
     * @return \Pcm\ArrayType\PcmArrayOfRadiusSearchMatch
     */
    public function setRadiusSearchMatch(array $radiusSearchMatch = array())
    {
        foreach ($radiusSearchMatch as $arrayOfRadiusSearchMatchRadiusSearchMatchItem) {
            // validation for constraint: itemType
            if (!$arrayOfRadiusSearchMatchRadiusSearchMatchItem instanceof \Pcm\StructType\PcmRadiusSearchMatch) {
                throw new \InvalidArgumentException(sprintf('The RadiusSearchMatch property can only contain items of \Pcm\StructType\PcmRadiusSearchMatch, "%s" given', is_object($arrayOfRadiusSearchMatchRadiusSearchMatchItem) ? get_class($arrayOfRadiusSearchMatchRadiusSearchMatchItem) : gettype($arrayOfRadiusSearchMatchRadiusSearchMatchItem)), __LINE__);
            }
        }
        if (is_null($radiusSearchMatch) || (is_array($radiusSearchMatch) && empty($radiusSearchMatch))) {
            unset($this->RadiusSearchMatch);
        } else {
            $this->RadiusSearchMatch = $radiusSearchMatch;
        }
        return $this;
    }
    /**
     * Add item to RadiusSearchMatch value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmRadiusSearchMatch $item
     * @return \Pcm\ArrayType\PcmArrayOfRadiusSearchMatch
     */
    public function addToRadiusSearchMatch(\Pcm\StructType\PcmRadiusSearchMatch $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmRadiusSearchMatch) {
            throw new \InvalidArgumentException(sprintf('The RadiusSearchMatch property can only contain items of \Pcm\StructType\PcmRadiusSearchMatch, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RadiusSearchMatch[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmRadiusSearchMatch|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmRadiusSearchMatch|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmRadiusSearchMatch|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmRadiusSearchMatch|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmRadiusSearchMatch|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RadiusSearchMatch
     */
    public function getAttributeName()
    {
        return 'RadiusSearchMatch';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfRadiusSearchMatch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
