<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReverseGeoCoord ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfReverseGeoCoord
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfReverseGeoCoord extends AbstractStructArrayBase
{
    /**
     * The ReverseGeoCoord
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmReverseGeoCoord[]
     */
    public $ReverseGeoCoord;
    /**
     * Constructor method for ArrayOfReverseGeoCoord
     * @uses PcmArrayOfReverseGeoCoord::setReverseGeoCoord()
     * @param \Pcm\StructType\PcmReverseGeoCoord[] $reverseGeoCoord
     */
    public function __construct(array $reverseGeoCoord = array())
    {
        $this
            ->setReverseGeoCoord($reverseGeoCoord);
    }
    /**
     * Get ReverseGeoCoord value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmReverseGeoCoord[]|null
     */
    public function getReverseGeoCoord()
    {
        return isset($this->ReverseGeoCoord) ? $this->ReverseGeoCoord : null;
    }
    /**
     * Set ReverseGeoCoord value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmReverseGeoCoord[] $reverseGeoCoord
     * @return \Pcm\ArrayType\PcmArrayOfReverseGeoCoord
     */
    public function setReverseGeoCoord(array $reverseGeoCoord = array())
    {
        foreach ($reverseGeoCoord as $arrayOfReverseGeoCoordReverseGeoCoordItem) {
            // validation for constraint: itemType
            if (!$arrayOfReverseGeoCoordReverseGeoCoordItem instanceof \Pcm\StructType\PcmReverseGeoCoord) {
                throw new \InvalidArgumentException(sprintf('The ReverseGeoCoord property can only contain items of \Pcm\StructType\PcmReverseGeoCoord, "%s" given', is_object($arrayOfReverseGeoCoordReverseGeoCoordItem) ? get_class($arrayOfReverseGeoCoordReverseGeoCoordItem) : gettype($arrayOfReverseGeoCoordReverseGeoCoordItem)), __LINE__);
            }
        }
        if (is_null($reverseGeoCoord) || (is_array($reverseGeoCoord) && empty($reverseGeoCoord))) {
            unset($this->ReverseGeoCoord);
        } else {
            $this->ReverseGeoCoord = $reverseGeoCoord;
        }
        return $this;
    }
    /**
     * Add item to ReverseGeoCoord value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmReverseGeoCoord $item
     * @return \Pcm\ArrayType\PcmArrayOfReverseGeoCoord
     */
    public function addToReverseGeoCoord(\Pcm\StructType\PcmReverseGeoCoord $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmReverseGeoCoord) {
            throw new \InvalidArgumentException(sprintf('The ReverseGeoCoord property can only contain items of \Pcm\StructType\PcmReverseGeoCoord, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ReverseGeoCoord[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmReverseGeoCoord|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmReverseGeoCoord|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmReverseGeoCoord|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmReverseGeoCoord|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmReverseGeoCoord|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReverseGeoCoord
     */
    public function getAttributeName()
    {
        return 'ReverseGeoCoord';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfReverseGeoCoord
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
