<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoadSpeedBase ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRoadSpeedBase
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfRoadSpeedBase extends AbstractStructArrayBase
{
    /**
     * The RoadSpeedBase
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmRoadSpeedBase[]
     */
    public $RoadSpeedBase;
    /**
     * Constructor method for ArrayOfRoadSpeedBase
     * @uses PcmArrayOfRoadSpeedBase::setRoadSpeedBase()
     * @param \Pcm\StructType\PcmRoadSpeedBase[] $roadSpeedBase
     */
    public function __construct(array $roadSpeedBase = array())
    {
        $this
            ->setRoadSpeedBase($roadSpeedBase);
    }
    /**
     * Get RoadSpeedBase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmRoadSpeedBase[]|null
     */
    public function getRoadSpeedBase()
    {
        return isset($this->RoadSpeedBase) ? $this->RoadSpeedBase : null;
    }
    /**
     * Set RoadSpeedBase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmRoadSpeedBase[] $roadSpeedBase
     * @return \Pcm\ArrayType\PcmArrayOfRoadSpeedBase
     */
    public function setRoadSpeedBase(array $roadSpeedBase = array())
    {
        foreach ($roadSpeedBase as $arrayOfRoadSpeedBaseRoadSpeedBaseItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoadSpeedBaseRoadSpeedBaseItem instanceof \Pcm\StructType\PcmRoadSpeedBase) {
                throw new \InvalidArgumentException(sprintf('The RoadSpeedBase property can only contain items of \Pcm\StructType\PcmRoadSpeedBase, "%s" given', is_object($arrayOfRoadSpeedBaseRoadSpeedBaseItem) ? get_class($arrayOfRoadSpeedBaseRoadSpeedBaseItem) : gettype($arrayOfRoadSpeedBaseRoadSpeedBaseItem)), __LINE__);
            }
        }
        if (is_null($roadSpeedBase) || (is_array($roadSpeedBase) && empty($roadSpeedBase))) {
            unset($this->RoadSpeedBase);
        } else {
            $this->RoadSpeedBase = $roadSpeedBase;
        }
        return $this;
    }
    /**
     * Add item to RoadSpeedBase value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmRoadSpeedBase $item
     * @return \Pcm\ArrayType\PcmArrayOfRoadSpeedBase
     */
    public function addToRoadSpeedBase(\Pcm\StructType\PcmRoadSpeedBase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmRoadSpeedBase) {
            throw new \InvalidArgumentException(sprintf('The RoadSpeedBase property can only contain items of \Pcm\StructType\PcmRoadSpeedBase, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RoadSpeedBase[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmRoadSpeedBase|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmRoadSpeedBase|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmRoadSpeedBase|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmRoadSpeedBase|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmRoadSpeedBase|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoadSpeedBase
     */
    public function getAttributeName()
    {
        return 'RoadSpeedBase';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfRoadSpeedBase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
