<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRouteLabelOptions ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRouteLabelOptions
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfRouteLabelOptions extends AbstractStructArrayBase
{
    /**
     * The RouteLabelOptions
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmRouteLabelOptions[]
     */
    public $RouteLabelOptions;
    /**
     * Constructor method for ArrayOfRouteLabelOptions
     * @uses PcmArrayOfRouteLabelOptions::setRouteLabelOptions()
     * @param \Pcm\StructType\PcmRouteLabelOptions[] $routeLabelOptions
     */
    public function __construct(array $routeLabelOptions = array())
    {
        $this
            ->setRouteLabelOptions($routeLabelOptions);
    }
    /**
     * Get RouteLabelOptions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmRouteLabelOptions[]|null
     */
    public function getRouteLabelOptions()
    {
        return isset($this->RouteLabelOptions) ? $this->RouteLabelOptions : null;
    }
    /**
     * Set RouteLabelOptions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmRouteLabelOptions[] $routeLabelOptions
     * @return \Pcm\ArrayType\PcmArrayOfRouteLabelOptions
     */
    public function setRouteLabelOptions(array $routeLabelOptions = array())
    {
        foreach ($routeLabelOptions as $arrayOfRouteLabelOptionsRouteLabelOptionsItem) {
            // validation for constraint: itemType
            if (!$arrayOfRouteLabelOptionsRouteLabelOptionsItem instanceof \Pcm\StructType\PcmRouteLabelOptions) {
                throw new \InvalidArgumentException(sprintf('The RouteLabelOptions property can only contain items of \Pcm\StructType\PcmRouteLabelOptions, "%s" given', is_object($arrayOfRouteLabelOptionsRouteLabelOptionsItem) ? get_class($arrayOfRouteLabelOptionsRouteLabelOptionsItem) : gettype($arrayOfRouteLabelOptionsRouteLabelOptionsItem)), __LINE__);
            }
        }
        if (is_null($routeLabelOptions) || (is_array($routeLabelOptions) && empty($routeLabelOptions))) {
            unset($this->RouteLabelOptions);
        } else {
            $this->RouteLabelOptions = $routeLabelOptions;
        }
        return $this;
    }
    /**
     * Add item to RouteLabelOptions value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmRouteLabelOptions $item
     * @return \Pcm\ArrayType\PcmArrayOfRouteLabelOptions
     */
    public function addToRouteLabelOptions(\Pcm\StructType\PcmRouteLabelOptions $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmRouteLabelOptions) {
            throw new \InvalidArgumentException(sprintf('The RouteLabelOptions property can only contain items of \Pcm\StructType\PcmRouteLabelOptions, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RouteLabelOptions[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmRouteLabelOptions|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmRouteLabelOptions|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmRouteLabelOptions|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmRouteLabelOptions|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmRouteLabelOptions|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RouteLabelOptions
     */
    public function getAttributeName()
    {
        return 'RouteLabelOptions';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfRouteLabelOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
