<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStateCostReportLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfStateCostReportLine
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfStateCostReportLine extends AbstractStructArrayBase
{
    /**
     * The StateCostReportLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmStateCostReportLine[]
     */
    public $StateCostReportLine;
    /**
     * Constructor method for ArrayOfStateCostReportLine
     * @uses PcmArrayOfStateCostReportLine::setStateCostReportLine()
     * @param \Pcm\StructType\PcmStateCostReportLine[] $stateCostReportLine
     */
    public function __construct(array $stateCostReportLine = array())
    {
        $this
            ->setStateCostReportLine($stateCostReportLine);
    }
    /**
     * Get StateCostReportLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmStateCostReportLine[]|null
     */
    public function getStateCostReportLine()
    {
        return isset($this->StateCostReportLine) ? $this->StateCostReportLine : null;
    }
    /**
     * Set StateCostReportLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmStateCostReportLine[] $stateCostReportLine
     * @return \Pcm\ArrayType\PcmArrayOfStateCostReportLine
     */
    public function setStateCostReportLine(array $stateCostReportLine = array())
    {
        foreach ($stateCostReportLine as $arrayOfStateCostReportLineStateCostReportLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfStateCostReportLineStateCostReportLineItem instanceof \Pcm\StructType\PcmStateCostReportLine) {
                throw new \InvalidArgumentException(sprintf('The StateCostReportLine property can only contain items of \Pcm\StructType\PcmStateCostReportLine, "%s" given', is_object($arrayOfStateCostReportLineStateCostReportLineItem) ? get_class($arrayOfStateCostReportLineStateCostReportLineItem) : gettype($arrayOfStateCostReportLineStateCostReportLineItem)), __LINE__);
            }
        }
        if (is_null($stateCostReportLine) || (is_array($stateCostReportLine) && empty($stateCostReportLine))) {
            unset($this->StateCostReportLine);
        } else {
            $this->StateCostReportLine = $stateCostReportLine;
        }
        return $this;
    }
    /**
     * Add item to StateCostReportLine value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmStateCostReportLine $item
     * @return \Pcm\ArrayType\PcmArrayOfStateCostReportLine
     */
    public function addToStateCostReportLine(\Pcm\StructType\PcmStateCostReportLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmStateCostReportLine) {
            throw new \InvalidArgumentException(sprintf('The StateCostReportLine property can only contain items of \Pcm\StructType\PcmStateCostReportLine, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StateCostReportLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmStateCostReportLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmStateCostReportLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmStateCostReportLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmStateCostReportLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmStateCostReportLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StateCostReportLine
     */
    public function getAttributeName()
    {
        return 'StateCostReportLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfStateCostReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
