<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTollDetailReportSegmentLine ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTollDetailReportSegmentLine
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfTollDetailReportSegmentLine extends AbstractStructArrayBase
{
    /**
     * The TollDetailReportSegmentLine
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmTollDetailReportSegmentLine[]
     */
    public $TollDetailReportSegmentLine;
    /**
     * Constructor method for ArrayOfTollDetailReportSegmentLine
     * @uses PcmArrayOfTollDetailReportSegmentLine::setTollDetailReportSegmentLine()
     * @param \Pcm\StructType\PcmTollDetailReportSegmentLine[] $tollDetailReportSegmentLine
     */
    public function __construct(array $tollDetailReportSegmentLine = array())
    {
        $this
            ->setTollDetailReportSegmentLine($tollDetailReportSegmentLine);
    }
    /**
     * Get TollDetailReportSegmentLine value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmTollDetailReportSegmentLine[]|null
     */
    public function getTollDetailReportSegmentLine()
    {
        return isset($this->TollDetailReportSegmentLine) ? $this->TollDetailReportSegmentLine : null;
    }
    /**
     * Set TollDetailReportSegmentLine value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmTollDetailReportSegmentLine[] $tollDetailReportSegmentLine
     * @return \Pcm\ArrayType\PcmArrayOfTollDetailReportSegmentLine
     */
    public function setTollDetailReportSegmentLine(array $tollDetailReportSegmentLine = array())
    {
        foreach ($tollDetailReportSegmentLine as $arrayOfTollDetailReportSegmentLineTollDetailReportSegmentLineItem) {
            // validation for constraint: itemType
            if (!$arrayOfTollDetailReportSegmentLineTollDetailReportSegmentLineItem instanceof \Pcm\StructType\PcmTollDetailReportSegmentLine) {
                throw new \InvalidArgumentException(sprintf('The TollDetailReportSegmentLine property can only contain items of \Pcm\StructType\PcmTollDetailReportSegmentLine, "%s" given', is_object($arrayOfTollDetailReportSegmentLineTollDetailReportSegmentLineItem) ? get_class($arrayOfTollDetailReportSegmentLineTollDetailReportSegmentLineItem) : gettype($arrayOfTollDetailReportSegmentLineTollDetailReportSegmentLineItem)), __LINE__);
            }
        }
        if (is_null($tollDetailReportSegmentLine) || (is_array($tollDetailReportSegmentLine) && empty($tollDetailReportSegmentLine))) {
            unset($this->TollDetailReportSegmentLine);
        } else {
            $this->TollDetailReportSegmentLine = $tollDetailReportSegmentLine;
        }
        return $this;
    }
    /**
     * Add item to TollDetailReportSegmentLine value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmTollDetailReportSegmentLine $item
     * @return \Pcm\ArrayType\PcmArrayOfTollDetailReportSegmentLine
     */
    public function addToTollDetailReportSegmentLine(\Pcm\StructType\PcmTollDetailReportSegmentLine $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmTollDetailReportSegmentLine) {
            throw new \InvalidArgumentException(sprintf('The TollDetailReportSegmentLine property can only contain items of \Pcm\StructType\PcmTollDetailReportSegmentLine, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TollDetailReportSegmentLine[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmTollDetailReportSegmentLine|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmTollDetailReportSegmentLine|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmTollDetailReportSegmentLine|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmTollDetailReportSegmentLine|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmTollDetailReportSegmentLine|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TollDetailReportSegmentLine
     */
    public function getAttributeName()
    {
        return 'TollDetailReportSegmentLine';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfTollDetailReportSegmentLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
