<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWeatherAlertEvent ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWeatherAlertEvent
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfWeatherAlertEvent extends AbstractStructArrayBase
{
    /**
     * The WeatherAlertEvent
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmWeatherAlertEvent[]
     */
    public $WeatherAlertEvent;
    /**
     * Constructor method for ArrayOfWeatherAlertEvent
     * @uses PcmArrayOfWeatherAlertEvent::setWeatherAlertEvent()
     * @param \Pcm\StructType\PcmWeatherAlertEvent[] $weatherAlertEvent
     */
    public function __construct(array $weatherAlertEvent = array())
    {
        $this
            ->setWeatherAlertEvent($weatherAlertEvent);
    }
    /**
     * Get WeatherAlertEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmWeatherAlertEvent[]|null
     */
    public function getWeatherAlertEvent()
    {
        return isset($this->WeatherAlertEvent) ? $this->WeatherAlertEvent : null;
    }
    /**
     * Set WeatherAlertEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmWeatherAlertEvent[] $weatherAlertEvent
     * @return \Pcm\ArrayType\PcmArrayOfWeatherAlertEvent
     */
    public function setWeatherAlertEvent(array $weatherAlertEvent = array())
    {
        foreach ($weatherAlertEvent as $arrayOfWeatherAlertEventWeatherAlertEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfWeatherAlertEventWeatherAlertEventItem instanceof \Pcm\StructType\PcmWeatherAlertEvent) {
                throw new \InvalidArgumentException(sprintf('The WeatherAlertEvent property can only contain items of \Pcm\StructType\PcmWeatherAlertEvent, "%s" given', is_object($arrayOfWeatherAlertEventWeatherAlertEventItem) ? get_class($arrayOfWeatherAlertEventWeatherAlertEventItem) : gettype($arrayOfWeatherAlertEventWeatherAlertEventItem)), __LINE__);
            }
        }
        if (is_null($weatherAlertEvent) || (is_array($weatherAlertEvent) && empty($weatherAlertEvent))) {
            unset($this->WeatherAlertEvent);
        } else {
            $this->WeatherAlertEvent = $weatherAlertEvent;
        }
        return $this;
    }
    /**
     * Add item to WeatherAlertEvent value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmWeatherAlertEvent $item
     * @return \Pcm\ArrayType\PcmArrayOfWeatherAlertEvent
     */
    public function addToWeatherAlertEvent(\Pcm\StructType\PcmWeatherAlertEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmWeatherAlertEvent) {
            throw new \InvalidArgumentException(sprintf('The WeatherAlertEvent property can only contain items of \Pcm\StructType\PcmWeatherAlertEvent, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->WeatherAlertEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmWeatherAlertEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmWeatherAlertEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmWeatherAlertEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmWeatherAlertEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmWeatherAlertEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WeatherAlertEvent
     */
    public function getAttributeName()
    {
        return 'WeatherAlertEvent';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfWeatherAlertEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
