<?php

namespace Pcm\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWeatherAlertsReport ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWeatherAlertsReport
 * @package Pcm
 * @subpackage Arrays
 */
class PcmArrayOfWeatherAlertsReport extends AbstractStructArrayBase
{
    /**
     * The WeatherAlertsReport
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmWeatherAlertsReport[]
     */
    public $WeatherAlertsReport;
    /**
     * Constructor method for ArrayOfWeatherAlertsReport
     * @uses PcmArrayOfWeatherAlertsReport::setWeatherAlertsReport()
     * @param \Pcm\StructType\PcmWeatherAlertsReport[] $weatherAlertsReport
     */
    public function __construct(array $weatherAlertsReport = array())
    {
        $this
            ->setWeatherAlertsReport($weatherAlertsReport);
    }
    /**
     * Get WeatherAlertsReport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmWeatherAlertsReport[]|null
     */
    public function getWeatherAlertsReport()
    {
        return isset($this->WeatherAlertsReport) ? $this->WeatherAlertsReport : null;
    }
    /**
     * Set WeatherAlertsReport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmWeatherAlertsReport[] $weatherAlertsReport
     * @return \Pcm\ArrayType\PcmArrayOfWeatherAlertsReport
     */
    public function setWeatherAlertsReport(array $weatherAlertsReport = array())
    {
        foreach ($weatherAlertsReport as $arrayOfWeatherAlertsReportWeatherAlertsReportItem) {
            // validation for constraint: itemType
            if (!$arrayOfWeatherAlertsReportWeatherAlertsReportItem instanceof \Pcm\StructType\PcmWeatherAlertsReport) {
                throw new \InvalidArgumentException(sprintf('The WeatherAlertsReport property can only contain items of \Pcm\StructType\PcmWeatherAlertsReport, "%s" given', is_object($arrayOfWeatherAlertsReportWeatherAlertsReportItem) ? get_class($arrayOfWeatherAlertsReportWeatherAlertsReportItem) : gettype($arrayOfWeatherAlertsReportWeatherAlertsReportItem)), __LINE__);
            }
        }
        if (is_null($weatherAlertsReport) || (is_array($weatherAlertsReport) && empty($weatherAlertsReport))) {
            unset($this->WeatherAlertsReport);
        } else {
            $this->WeatherAlertsReport = $weatherAlertsReport;
        }
        return $this;
    }
    /**
     * Add item to WeatherAlertsReport value
     * @throws \InvalidArgumentException
     * @param \Pcm\StructType\PcmWeatherAlertsReport $item
     * @return \Pcm\ArrayType\PcmArrayOfWeatherAlertsReport
     */
    public function addToWeatherAlertsReport(\Pcm\StructType\PcmWeatherAlertsReport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pcm\StructType\PcmWeatherAlertsReport) {
            throw new \InvalidArgumentException(sprintf('The WeatherAlertsReport property can only contain items of \Pcm\StructType\PcmWeatherAlertsReport, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->WeatherAlertsReport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pcm\StructType\PcmWeatherAlertsReport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pcm\StructType\PcmWeatherAlertsReport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pcm\StructType\PcmWeatherAlertsReport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pcm\StructType\PcmWeatherAlertsReport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pcm\StructType\PcmWeatherAlertsReport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WeatherAlertsReport
     */
    public function getAttributeName()
    {
        return 'WeatherAlertsReport';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\ArrayType\PcmArrayOfWeatherAlertsReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
