<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ALKPen StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ALKPen
 * @package Pcm
 * @subpackage Structs
 */
class PcmALKPen extends AbstractStructBase
{
    /**
     * The Color
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmRGB
     */
    public $Color;
    /**
     * The Widths
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Widths;
    /**
     * The Widths1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Widths1;
    /**
     * The Widths2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Widths2;
    /**
     * The Widths3
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Widths3;
    /**
     * Constructor method for ALKPen
     * @uses PcmALKPen::setColor()
     * @uses PcmALKPen::setWidths()
     * @uses PcmALKPen::setWidths1()
     * @uses PcmALKPen::setWidths2()
     * @uses PcmALKPen::setWidths3()
     * @param \Pcm\StructType\PcmRGB $color
     * @param string $widths
     * @param string $widths1
     * @param string $widths2
     * @param string $widths3
     */
    public function __construct(\Pcm\StructType\PcmRGB $color = null, $widths = null, $widths1 = null, $widths2 = null, $widths3 = null)
    {
        $this
            ->setColor($color)
            ->setWidths($widths)
            ->setWidths1($widths1)
            ->setWidths2($widths2)
            ->setWidths3($widths3);
    }
    /**
     * Get Color value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmRGB|null
     */
    public function getColor()
    {
        return isset($this->Color) ? $this->Color : null;
    }
    /**
     * Set Color value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmRGB $color
     * @return \Pcm\StructType\PcmALKPen
     */
    public function setColor(\Pcm\StructType\PcmRGB $color = null)
    {
        if (is_null($color) || (is_array($color) && empty($color))) {
            unset($this->Color);
        } else {
            $this->Color = $color;
        }
        return $this;
    }
    /**
     * Get Widths value
     * @return string|null
     */
    public function getWidths()
    {
        return $this->Widths;
    }
    /**
     * Set Widths value
     * @param string $widths
     * @return \Pcm\StructType\PcmALKPen
     */
    public function setWidths($widths = null)
    {
        // validation for constraint: string
        if (!is_null($widths) && !is_string($widths)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($widths)), __LINE__);
        }
        $this->Widths = $widths;
        return $this;
    }
    /**
     * Get Widths1 value
     * @return string|null
     */
    public function getWidths1()
    {
        return $this->Widths1;
    }
    /**
     * Set Widths1 value
     * @param string $widths1
     * @return \Pcm\StructType\PcmALKPen
     */
    public function setWidths1($widths1 = null)
    {
        // validation for constraint: string
        if (!is_null($widths1) && !is_string($widths1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($widths1)), __LINE__);
        }
        $this->Widths1 = $widths1;
        return $this;
    }
    /**
     * Get Widths2 value
     * @return string|null
     */
    public function getWidths2()
    {
        return $this->Widths2;
    }
    /**
     * Set Widths2 value
     * @param string $widths2
     * @return \Pcm\StructType\PcmALKPen
     */
    public function setWidths2($widths2 = null)
    {
        // validation for constraint: string
        if (!is_null($widths2) && !is_string($widths2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($widths2)), __LINE__);
        }
        $this->Widths2 = $widths2;
        return $this;
    }
    /**
     * Get Widths3 value
     * @return string|null
     */
    public function getWidths3()
    {
        return $this->Widths3;
    }
    /**
     * Set Widths3 value
     * @param string $widths3
     * @return \Pcm\StructType\PcmALKPen
     */
    public function setWidths3($widths3 = null)
    {
        // validation for constraint: string
        if (!is_null($widths3) && !is_string($widths3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($widths3)), __LINE__);
        }
        $this->Widths3 = $widths3;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmALKPen
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
