<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DirectionsReportLine StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:DirectionsReportLine
 * @package Pcm
 * @subpackage Structs
 */
class PcmDirectionsReportLine extends AbstractStructBase
{
    /**
     * The Warn
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Warn;
    /**
     * The Direction
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Direction;
    /**
     * The Dist
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Dist;
    /**
     * The Time
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Time;
    /**
     * The InterCh
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InterCh;
    /**
     * The Delay
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Delay;
    /**
     * Constructor method for DirectionsReportLine
     * @uses PcmDirectionsReportLine::setWarn()
     * @uses PcmDirectionsReportLine::setDirection()
     * @uses PcmDirectionsReportLine::setDist()
     * @uses PcmDirectionsReportLine::setTime()
     * @uses PcmDirectionsReportLine::setInterCh()
     * @uses PcmDirectionsReportLine::setDelay()
     * @param string $warn
     * @param string $direction
     * @param string $dist
     * @param string $time
     * @param string $interCh
     * @param string $delay
     */
    public function __construct($warn = null, $direction = null, $dist = null, $time = null, $interCh = null, $delay = null)
    {
        $this
            ->setWarn($warn)
            ->setDirection($direction)
            ->setDist($dist)
            ->setTime($time)
            ->setInterCh($interCh)
            ->setDelay($delay);
    }
    /**
     * Get Warn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarn()
    {
        return isset($this->Warn) ? $this->Warn : null;
    }
    /**
     * Set Warn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warn
     * @return \Pcm\StructType\PcmDirectionsReportLine
     */
    public function setWarn($warn = null)
    {
        // validation for constraint: string
        if (!is_null($warn) && !is_string($warn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($warn)), __LINE__);
        }
        if (is_null($warn) || (is_array($warn) && empty($warn))) {
            unset($this->Warn);
        } else {
            $this->Warn = $warn;
        }
        return $this;
    }
    /**
     * Get Direction value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDirection()
    {
        return isset($this->Direction) ? $this->Direction : null;
    }
    /**
     * Set Direction value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $direction
     * @return \Pcm\StructType\PcmDirectionsReportLine
     */
    public function setDirection($direction = null)
    {
        // validation for constraint: string
        if (!is_null($direction) && !is_string($direction)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($direction)), __LINE__);
        }
        if (is_null($direction) || (is_array($direction) && empty($direction))) {
            unset($this->Direction);
        } else {
            $this->Direction = $direction;
        }
        return $this;
    }
    /**
     * Get Dist value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDist()
    {
        return isset($this->Dist) ? $this->Dist : null;
    }
    /**
     * Set Dist value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dist
     * @return \Pcm\StructType\PcmDirectionsReportLine
     */
    public function setDist($dist = null)
    {
        // validation for constraint: string
        if (!is_null($dist) && !is_string($dist)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dist)), __LINE__);
        }
        if (is_null($dist) || (is_array($dist) && empty($dist))) {
            unset($this->Dist);
        } else {
            $this->Dist = $dist;
        }
        return $this;
    }
    /**
     * Get Time value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTime()
    {
        return isset($this->Time) ? $this->Time : null;
    }
    /**
     * Set Time value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $time
     * @return \Pcm\StructType\PcmDirectionsReportLine
     */
    public function setTime($time = null)
    {
        // validation for constraint: string
        if (!is_null($time) && !is_string($time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($time)), __LINE__);
        }
        if (is_null($time) || (is_array($time) && empty($time))) {
            unset($this->Time);
        } else {
            $this->Time = $time;
        }
        return $this;
    }
    /**
     * Get InterCh value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInterCh()
    {
        return isset($this->InterCh) ? $this->InterCh : null;
    }
    /**
     * Set InterCh value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $interCh
     * @return \Pcm\StructType\PcmDirectionsReportLine
     */
    public function setInterCh($interCh = null)
    {
        // validation for constraint: string
        if (!is_null($interCh) && !is_string($interCh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($interCh)), __LINE__);
        }
        if (is_null($interCh) || (is_array($interCh) && empty($interCh))) {
            unset($this->InterCh);
        } else {
            $this->InterCh = $interCh;
        }
        return $this;
    }
    /**
     * Get Delay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDelay()
    {
        return isset($this->Delay) ? $this->Delay : null;
    }
    /**
     * Set Delay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $delay
     * @return \Pcm\StructType\PcmDirectionsReportLine
     */
    public function setDelay($delay = null)
    {
        // validation for constraint: string
        if (!is_null($delay) && !is_string($delay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($delay)), __LINE__);
        }
        if (is_null($delay) || (is_array($delay) && empty($delay))) {
            unset($this->Delay);
        } else {
            $this->Delay = $delay;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmDirectionsReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
