<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FuelReport StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:FuelReport
 * @package Pcm
 * @subpackage Structs
 */
class PcmFuelReport extends PcmReport
{
    /**
     * The FuelStops
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\ArrayType\PcmArrayOfFuelStopLine
     */
    public $FuelStops;
    /**
     * The FuelSummary
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmFuelReportSummary
     */
    public $FuelSummary;
    /**
     * Constructor method for FuelReport
     * @uses PcmFuelReport::setFuelStops()
     * @uses PcmFuelReport::setFuelSummary()
     * @param \Pcm\ArrayType\PcmArrayOfFuelStopLine $fuelStops
     * @param \Pcm\StructType\PcmFuelReportSummary $fuelSummary
     */
    public function __construct(\Pcm\ArrayType\PcmArrayOfFuelStopLine $fuelStops = null, \Pcm\StructType\PcmFuelReportSummary $fuelSummary = null)
    {
        $this
            ->setFuelStops($fuelStops)
            ->setFuelSummary($fuelSummary);
    }
    /**
     * Get FuelStops value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\ArrayType\PcmArrayOfFuelStopLine|null
     */
    public function getFuelStops()
    {
        return isset($this->FuelStops) ? $this->FuelStops : null;
    }
    /**
     * Set FuelStops value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\ArrayType\PcmArrayOfFuelStopLine $fuelStops
     * @return \Pcm\StructType\PcmFuelReport
     */
    public function setFuelStops(\Pcm\ArrayType\PcmArrayOfFuelStopLine $fuelStops = null)
    {
        if (is_null($fuelStops) || (is_array($fuelStops) && empty($fuelStops))) {
            unset($this->FuelStops);
        } else {
            $this->FuelStops = $fuelStops;
        }
        return $this;
    }
    /**
     * Get FuelSummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmFuelReportSummary|null
     */
    public function getFuelSummary()
    {
        return isset($this->FuelSummary) ? $this->FuelSummary : null;
    }
    /**
     * Set FuelSummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmFuelReportSummary $fuelSummary
     * @return \Pcm\StructType\PcmFuelReport
     */
    public function setFuelSummary(\Pcm\StructType\PcmFuelReportSummary $fuelSummary = null)
    {
        if (is_null($fuelSummary) || (is_array($fuelSummary) && empty($fuelSummary))) {
            unset($this->FuelSummary);
        } else {
            $this->FuelSummary = $fuelSummary;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmFuelReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
