<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeoTunnelReport StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:GeoTunnelReport
 * @package Pcm
 * @subpackage Structs
 */
class PcmGeoTunnelReport extends PcmReport
{
    /**
     * The GeoTunnelPoints
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\ArrayType\PcmArrayOfCoordinates
     */
    public $GeoTunnelPoints;
    /**
     * Constructor method for GeoTunnelReport
     * @uses PcmGeoTunnelReport::setGeoTunnelPoints()
     * @param \Pcm\ArrayType\PcmArrayOfCoordinates $geoTunnelPoints
     */
    public function __construct(\Pcm\ArrayType\PcmArrayOfCoordinates $geoTunnelPoints = null)
    {
        $this
            ->setGeoTunnelPoints($geoTunnelPoints);
    }
    /**
     * Get GeoTunnelPoints value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\ArrayType\PcmArrayOfCoordinates|null
     */
    public function getGeoTunnelPoints()
    {
        return isset($this->GeoTunnelPoints) ? $this->GeoTunnelPoints : null;
    }
    /**
     * Set GeoTunnelPoints value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\ArrayType\PcmArrayOfCoordinates $geoTunnelPoints
     * @return \Pcm\StructType\PcmGeoTunnelReport
     */
    public function setGeoTunnelPoints(\Pcm\ArrayType\PcmArrayOfCoordinates $geoTunnelPoints = null)
    {
        if (is_null($geoTunnelPoints) || (is_array($geoTunnelPoints) && empty($geoTunnelPoints))) {
            unset($this->GeoTunnelPoints);
        } else {
            $this->GeoTunnelPoints = $geoTunnelPoints;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmGeoTunnelReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
