<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StateCostReportLine StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:StateCostReportLine
 * @package Pcm
 * @subpackage Structs
 */
class PcmStateCostReportLine extends AbstractStructBase
{
    /**
     * The StCntry
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StCntry;
    /**
     * The Total
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Total;
    /**
     * The Toll
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Toll;
    /**
     * The Free
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Free;
    /**
     * The Ferry
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Ferry;
    /**
     * The Loaded
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Loaded;
    /**
     * The Empty
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Empty;
    /**
     * The Tolls
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tolls;
    /**
     * The Energy
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Energy;
    /**
     * Constructor method for StateCostReportLine
     * @uses PcmStateCostReportLine::setStCntry()
     * @uses PcmStateCostReportLine::setTotal()
     * @uses PcmStateCostReportLine::setToll()
     * @uses PcmStateCostReportLine::setFree()
     * @uses PcmStateCostReportLine::setFerry()
     * @uses PcmStateCostReportLine::setLoaded()
     * @uses PcmStateCostReportLine::setEmpty()
     * @uses PcmStateCostReportLine::setTolls()
     * @uses PcmStateCostReportLine::setEnergy()
     * @param string $stCntry
     * @param string $total
     * @param string $toll
     * @param string $free
     * @param string $ferry
     * @param string $loaded
     * @param string $empty
     * @param string $tolls
     * @param string $energy
     */
    public function __construct($stCntry = null, $total = null, $toll = null, $free = null, $ferry = null, $loaded = null, $empty = null, $tolls = null, $energy = null)
    {
        $this
            ->setStCntry($stCntry)
            ->setTotal($total)
            ->setToll($toll)
            ->setFree($free)
            ->setFerry($ferry)
            ->setLoaded($loaded)
            ->setEmpty($empty)
            ->setTolls($tolls)
            ->setEnergy($energy);
    }
    /**
     * Get StCntry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStCntry()
    {
        return isset($this->StCntry) ? $this->StCntry : null;
    }
    /**
     * Set StCntry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $stCntry
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setStCntry($stCntry = null)
    {
        // validation for constraint: string
        if (!is_null($stCntry) && !is_string($stCntry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($stCntry)), __LINE__);
        }
        if (is_null($stCntry) || (is_array($stCntry) && empty($stCntry))) {
            unset($this->StCntry);
        } else {
            $this->StCntry = $stCntry;
        }
        return $this;
    }
    /**
     * Get Total value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTotal()
    {
        return isset($this->Total) ? $this->Total : null;
    }
    /**
     * Set Total value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $total
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setTotal($total = null)
    {
        // validation for constraint: string
        if (!is_null($total) && !is_string($total)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($total)), __LINE__);
        }
        if (is_null($total) || (is_array($total) && empty($total))) {
            unset($this->Total);
        } else {
            $this->Total = $total;
        }
        return $this;
    }
    /**
     * Get Toll value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getToll()
    {
        return isset($this->Toll) ? $this->Toll : null;
    }
    /**
     * Set Toll value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $toll
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setToll($toll = null)
    {
        // validation for constraint: string
        if (!is_null($toll) && !is_string($toll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($toll)), __LINE__);
        }
        if (is_null($toll) || (is_array($toll) && empty($toll))) {
            unset($this->Toll);
        } else {
            $this->Toll = $toll;
        }
        return $this;
    }
    /**
     * Get Free value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFree()
    {
        return isset($this->Free) ? $this->Free : null;
    }
    /**
     * Set Free value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $free
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setFree($free = null)
    {
        // validation for constraint: string
        if (!is_null($free) && !is_string($free)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($free)), __LINE__);
        }
        if (is_null($free) || (is_array($free) && empty($free))) {
            unset($this->Free);
        } else {
            $this->Free = $free;
        }
        return $this;
    }
    /**
     * Get Ferry value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFerry()
    {
        return isset($this->Ferry) ? $this->Ferry : null;
    }
    /**
     * Set Ferry value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ferry
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setFerry($ferry = null)
    {
        // validation for constraint: string
        if (!is_null($ferry) && !is_string($ferry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ferry)), __LINE__);
        }
        if (is_null($ferry) || (is_array($ferry) && empty($ferry))) {
            unset($this->Ferry);
        } else {
            $this->Ferry = $ferry;
        }
        return $this;
    }
    /**
     * Get Loaded value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoaded()
    {
        return isset($this->Loaded) ? $this->Loaded : null;
    }
    /**
     * Set Loaded value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loaded
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setLoaded($loaded = null)
    {
        // validation for constraint: string
        if (!is_null($loaded) && !is_string($loaded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($loaded)), __LINE__);
        }
        if (is_null($loaded) || (is_array($loaded) && empty($loaded))) {
            unset($this->Loaded);
        } else {
            $this->Loaded = $loaded;
        }
        return $this;
    }
    /**
     * Get Empty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmpty()
    {
        return isset($this->Empty) ? $this->Empty : null;
    }
    /**
     * Set Empty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $empty
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setEmpty($empty = null)
    {
        // validation for constraint: string
        if (!is_null($empty) && !is_string($empty)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($empty)), __LINE__);
        }
        if (is_null($empty) || (is_array($empty) && empty($empty))) {
            unset($this->Empty);
        } else {
            $this->Empty = $empty;
        }
        return $this;
    }
    /**
     * Get Tolls value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTolls()
    {
        return isset($this->Tolls) ? $this->Tolls : null;
    }
    /**
     * Set Tolls value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tolls
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setTolls($tolls = null)
    {
        // validation for constraint: string
        if (!is_null($tolls) && !is_string($tolls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tolls)), __LINE__);
        }
        if (is_null($tolls) || (is_array($tolls) && empty($tolls))) {
            unset($this->Tolls);
        } else {
            $this->Tolls = $tolls;
        }
        return $this;
    }
    /**
     * Get Energy value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEnergy()
    {
        return isset($this->Energy) ? $this->Energy : null;
    }
    /**
     * Set Energy value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $energy
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public function setEnergy($energy = null)
    {
        // validation for constraint: string
        if (!is_null($energy) && !is_string($energy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($energy)), __LINE__);
        }
        if (is_null($energy) || (is_array($energy) && empty($energy))) {
            unset($this->Energy);
        } else {
            $this->Energy = $energy;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmStateCostReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
