<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StopLocation StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:StopLocation
 * @package Pcm
 * @subpackage Structs
 */
class PcmStopLocation extends PcmLocation
{
    /**
     * The Costs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmStopCosts
     */
    public $Costs;
    /**
     * The IsViaPoint
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsViaPoint;
    /**
     * Constructor method for StopLocation
     * @uses PcmStopLocation::setCosts()
     * @uses PcmStopLocation::setIsViaPoint()
     * @param \Pcm\StructType\PcmStopCosts $costs
     * @param bool $isViaPoint
     */
    public function __construct(\Pcm\StructType\PcmStopCosts $costs = null, $isViaPoint = null)
    {
        $this
            ->setCosts($costs)
            ->setIsViaPoint($isViaPoint);
    }
    /**
     * Get Costs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmStopCosts|null
     */
    public function getCosts()
    {
        return isset($this->Costs) ? $this->Costs : null;
    }
    /**
     * Set Costs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmStopCosts $costs
     * @return \Pcm\StructType\PcmStopLocation
     */
    public function setCosts(\Pcm\StructType\PcmStopCosts $costs = null)
    {
        if (is_null($costs) || (is_array($costs) && empty($costs))) {
            unset($this->Costs);
        } else {
            $this->Costs = $costs;
        }
        return $this;
    }
    /**
     * Get IsViaPoint value
     * @return bool|null
     */
    public function getIsViaPoint()
    {
        return $this->IsViaPoint;
    }
    /**
     * Set IsViaPoint value
     * @param bool $isViaPoint
     * @return \Pcm\StructType\PcmStopLocation
     */
    public function setIsViaPoint($isViaPoint = null)
    {
        $this->IsViaPoint = $isViaPoint;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmStopLocation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
