<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StopReportLine StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:StopReportLine
 * @package Pcm
 * @subpackage Structs
 */
class PcmStopReportLine extends AbstractStructBase
{
    /**
     * The Stop
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pcm\StructType\PcmGeocodeOutputLocation
     */
    public $Stop;
    /**
     * The LMiles
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LMiles;
    /**
     * The TMiles
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TMiles;
    /**
     * The LCostMile
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LCostMile;
    /**
     * The TCostMile
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TCostMile;
    /**
     * The LHours
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LHours;
    /**
     * The THours
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $THours;
    /**
     * The LTolls
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LTolls;
    /**
     * The TTolls
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TTolls;
    /**
     * The LEstghg
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LEstghg;
    /**
     * The TEstghg
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TEstghg;
    /**
     * The EtaEtd
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EtaEtd;
    /**
     * Constructor method for StopReportLine
     * @uses PcmStopReportLine::setStop()
     * @uses PcmStopReportLine::setLMiles()
     * @uses PcmStopReportLine::setTMiles()
     * @uses PcmStopReportLine::setLCostMile()
     * @uses PcmStopReportLine::setTCostMile()
     * @uses PcmStopReportLine::setLHours()
     * @uses PcmStopReportLine::setTHours()
     * @uses PcmStopReportLine::setLTolls()
     * @uses PcmStopReportLine::setTTolls()
     * @uses PcmStopReportLine::setLEstghg()
     * @uses PcmStopReportLine::setTEstghg()
     * @uses PcmStopReportLine::setEtaEtd()
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $stop
     * @param string $lMiles
     * @param string $tMiles
     * @param string $lCostMile
     * @param string $tCostMile
     * @param string $lHours
     * @param string $tHours
     * @param string $lTolls
     * @param string $tTolls
     * @param string $lEstghg
     * @param string $tEstghg
     * @param string $etaEtd
     */
    public function __construct(\Pcm\StructType\PcmGeocodeOutputLocation $stop = null, $lMiles = null, $tMiles = null, $lCostMile = null, $tCostMile = null, $lHours = null, $tHours = null, $lTolls = null, $tTolls = null, $lEstghg = null, $tEstghg = null, $etaEtd = null)
    {
        $this
            ->setStop($stop)
            ->setLMiles($lMiles)
            ->setTMiles($tMiles)
            ->setLCostMile($lCostMile)
            ->setTCostMile($tCostMile)
            ->setLHours($lHours)
            ->setTHours($tHours)
            ->setLTolls($lTolls)
            ->setTTolls($tTolls)
            ->setLEstghg($lEstghg)
            ->setTEstghg($tEstghg)
            ->setEtaEtd($etaEtd);
    }
    /**
     * Get Stop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pcm\StructType\PcmGeocodeOutputLocation|null
     */
    public function getStop()
    {
        return isset($this->Stop) ? $this->Stop : null;
    }
    /**
     * Set Stop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pcm\StructType\PcmGeocodeOutputLocation $stop
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setStop(\Pcm\StructType\PcmGeocodeOutputLocation $stop = null)
    {
        if (is_null($stop) || (is_array($stop) && empty($stop))) {
            unset($this->Stop);
        } else {
            $this->Stop = $stop;
        }
        return $this;
    }
    /**
     * Get LMiles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLMiles()
    {
        return isset($this->LMiles) ? $this->LMiles : null;
    }
    /**
     * Set LMiles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lMiles
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setLMiles($lMiles = null)
    {
        // validation for constraint: string
        if (!is_null($lMiles) && !is_string($lMiles)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lMiles)), __LINE__);
        }
        if (is_null($lMiles) || (is_array($lMiles) && empty($lMiles))) {
            unset($this->LMiles);
        } else {
            $this->LMiles = $lMiles;
        }
        return $this;
    }
    /**
     * Get TMiles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTMiles()
    {
        return isset($this->TMiles) ? $this->TMiles : null;
    }
    /**
     * Set TMiles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tMiles
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setTMiles($tMiles = null)
    {
        // validation for constraint: string
        if (!is_null($tMiles) && !is_string($tMiles)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tMiles)), __LINE__);
        }
        if (is_null($tMiles) || (is_array($tMiles) && empty($tMiles))) {
            unset($this->TMiles);
        } else {
            $this->TMiles = $tMiles;
        }
        return $this;
    }
    /**
     * Get LCostMile value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLCostMile()
    {
        return isset($this->LCostMile) ? $this->LCostMile : null;
    }
    /**
     * Set LCostMile value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lCostMile
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setLCostMile($lCostMile = null)
    {
        // validation for constraint: string
        if (!is_null($lCostMile) && !is_string($lCostMile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lCostMile)), __LINE__);
        }
        if (is_null($lCostMile) || (is_array($lCostMile) && empty($lCostMile))) {
            unset($this->LCostMile);
        } else {
            $this->LCostMile = $lCostMile;
        }
        return $this;
    }
    /**
     * Get TCostMile value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTCostMile()
    {
        return isset($this->TCostMile) ? $this->TCostMile : null;
    }
    /**
     * Set TCostMile value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tCostMile
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setTCostMile($tCostMile = null)
    {
        // validation for constraint: string
        if (!is_null($tCostMile) && !is_string($tCostMile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tCostMile)), __LINE__);
        }
        if (is_null($tCostMile) || (is_array($tCostMile) && empty($tCostMile))) {
            unset($this->TCostMile);
        } else {
            $this->TCostMile = $tCostMile;
        }
        return $this;
    }
    /**
     * Get LHours value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLHours()
    {
        return isset($this->LHours) ? $this->LHours : null;
    }
    /**
     * Set LHours value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lHours
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setLHours($lHours = null)
    {
        // validation for constraint: string
        if (!is_null($lHours) && !is_string($lHours)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lHours)), __LINE__);
        }
        if (is_null($lHours) || (is_array($lHours) && empty($lHours))) {
            unset($this->LHours);
        } else {
            $this->LHours = $lHours;
        }
        return $this;
    }
    /**
     * Get THours value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTHours()
    {
        return isset($this->THours) ? $this->THours : null;
    }
    /**
     * Set THours value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tHours
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setTHours($tHours = null)
    {
        // validation for constraint: string
        if (!is_null($tHours) && !is_string($tHours)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tHours)), __LINE__);
        }
        if (is_null($tHours) || (is_array($tHours) && empty($tHours))) {
            unset($this->THours);
        } else {
            $this->THours = $tHours;
        }
        return $this;
    }
    /**
     * Get LTolls value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLTolls()
    {
        return isset($this->LTolls) ? $this->LTolls : null;
    }
    /**
     * Set LTolls value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lTolls
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setLTolls($lTolls = null)
    {
        // validation for constraint: string
        if (!is_null($lTolls) && !is_string($lTolls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lTolls)), __LINE__);
        }
        if (is_null($lTolls) || (is_array($lTolls) && empty($lTolls))) {
            unset($this->LTolls);
        } else {
            $this->LTolls = $lTolls;
        }
        return $this;
    }
    /**
     * Get TTolls value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTTolls()
    {
        return isset($this->TTolls) ? $this->TTolls : null;
    }
    /**
     * Set TTolls value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tTolls
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setTTolls($tTolls = null)
    {
        // validation for constraint: string
        if (!is_null($tTolls) && !is_string($tTolls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tTolls)), __LINE__);
        }
        if (is_null($tTolls) || (is_array($tTolls) && empty($tTolls))) {
            unset($this->TTolls);
        } else {
            $this->TTolls = $tTolls;
        }
        return $this;
    }
    /**
     * Get LEstghg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLEstghg()
    {
        return isset($this->LEstghg) ? $this->LEstghg : null;
    }
    /**
     * Set LEstghg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lEstghg
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setLEstghg($lEstghg = null)
    {
        // validation for constraint: string
        if (!is_null($lEstghg) && !is_string($lEstghg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lEstghg)), __LINE__);
        }
        if (is_null($lEstghg) || (is_array($lEstghg) && empty($lEstghg))) {
            unset($this->LEstghg);
        } else {
            $this->LEstghg = $lEstghg;
        }
        return $this;
    }
    /**
     * Get TEstghg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTEstghg()
    {
        return isset($this->TEstghg) ? $this->TEstghg : null;
    }
    /**
     * Set TEstghg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tEstghg
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setTEstghg($tEstghg = null)
    {
        // validation for constraint: string
        if (!is_null($tEstghg) && !is_string($tEstghg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tEstghg)), __LINE__);
        }
        if (is_null($tEstghg) || (is_array($tEstghg) && empty($tEstghg))) {
            unset($this->TEstghg);
        } else {
            $this->TEstghg = $tEstghg;
        }
        return $this;
    }
    /**
     * Get EtaEtd value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEtaEtd()
    {
        return isset($this->EtaEtd) ? $this->EtaEtd : null;
    }
    /**
     * Set EtaEtd value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $etaEtd
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public function setEtaEtd($etaEtd = null)
    {
        // validation for constraint: string
        if (!is_null($etaEtd) && !is_string($etaEtd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($etaEtd)), __LINE__);
        }
        if (is_null($etaEtd) || (is_array($etaEtd) && empty($etaEtd))) {
            unset($this->EtaEtd);
        } else {
            $this->EtaEtd = $etaEtd;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmStopReportLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
