<?php

namespace Pcm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TollDetailReportSummaryLine StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:TollDetailReportSummaryLine
 * @package Pcm
 * @subpackage Structs
 */
class PcmTollDetailReportSummaryLine extends AbstractStructBase
{
    /**
     * The Country
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Country;
    /**
     * The TollType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TollType;
    /**
     * The TollName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TollName;
    /**
     * The TollDistance
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TollDistance;
    /**
     * The TollsLocal
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TollsLocal;
    /**
     * The Tolls
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tolls;
    /**
     * The PaymentOption
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PaymentOption;
    /**
     * Constructor method for TollDetailReportSummaryLine
     * @uses PcmTollDetailReportSummaryLine::setCountry()
     * @uses PcmTollDetailReportSummaryLine::setTollType()
     * @uses PcmTollDetailReportSummaryLine::setTollName()
     * @uses PcmTollDetailReportSummaryLine::setTollDistance()
     * @uses PcmTollDetailReportSummaryLine::setTollsLocal()
     * @uses PcmTollDetailReportSummaryLine::setTolls()
     * @uses PcmTollDetailReportSummaryLine::setPaymentOption()
     * @param string $country
     * @param string $tollType
     * @param string $tollName
     * @param string $tollDistance
     * @param string $tollsLocal
     * @param string $tolls
     * @param string $paymentOption
     */
    public function __construct($country = null, $tollType = null, $tollName = null, $tollDistance = null, $tollsLocal = null, $tolls = null, $paymentOption = null)
    {
        $this
            ->setCountry($country)
            ->setTollType($tollType)
            ->setTollName($tollName)
            ->setTollDistance($tollDistance)
            ->setTollsLocal($tollsLocal)
            ->setTolls($tolls)
            ->setPaymentOption($paymentOption);
    }
    /**
     * Get Country value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCountry()
    {
        return isset($this->Country) ? $this->Country : null;
    }
    /**
     * Set Country value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $country
     * @return \Pcm\StructType\PcmTollDetailReportSummaryLine
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($country)), __LINE__);
        }
        if (is_null($country) || (is_array($country) && empty($country))) {
            unset($this->Country);
        } else {
            $this->Country = $country;
        }
        return $this;
    }
    /**
     * Get TollType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTollType()
    {
        return isset($this->TollType) ? $this->TollType : null;
    }
    /**
     * Set TollType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tollType
     * @return \Pcm\StructType\PcmTollDetailReportSummaryLine
     */
    public function setTollType($tollType = null)
    {
        // validation for constraint: string
        if (!is_null($tollType) && !is_string($tollType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tollType)), __LINE__);
        }
        if (is_null($tollType) || (is_array($tollType) && empty($tollType))) {
            unset($this->TollType);
        } else {
            $this->TollType = $tollType;
        }
        return $this;
    }
    /**
     * Get TollName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTollName()
    {
        return isset($this->TollName) ? $this->TollName : null;
    }
    /**
     * Set TollName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tollName
     * @return \Pcm\StructType\PcmTollDetailReportSummaryLine
     */
    public function setTollName($tollName = null)
    {
        // validation for constraint: string
        if (!is_null($tollName) && !is_string($tollName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tollName)), __LINE__);
        }
        if (is_null($tollName) || (is_array($tollName) && empty($tollName))) {
            unset($this->TollName);
        } else {
            $this->TollName = $tollName;
        }
        return $this;
    }
    /**
     * Get TollDistance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTollDistance()
    {
        return isset($this->TollDistance) ? $this->TollDistance : null;
    }
    /**
     * Set TollDistance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tollDistance
     * @return \Pcm\StructType\PcmTollDetailReportSummaryLine
     */
    public function setTollDistance($tollDistance = null)
    {
        // validation for constraint: string
        if (!is_null($tollDistance) && !is_string($tollDistance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tollDistance)), __LINE__);
        }
        if (is_null($tollDistance) || (is_array($tollDistance) && empty($tollDistance))) {
            unset($this->TollDistance);
        } else {
            $this->TollDistance = $tollDistance;
        }
        return $this;
    }
    /**
     * Get TollsLocal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTollsLocal()
    {
        return isset($this->TollsLocal) ? $this->TollsLocal : null;
    }
    /**
     * Set TollsLocal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tollsLocal
     * @return \Pcm\StructType\PcmTollDetailReportSummaryLine
     */
    public function setTollsLocal($tollsLocal = null)
    {
        // validation for constraint: string
        if (!is_null($tollsLocal) && !is_string($tollsLocal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tollsLocal)), __LINE__);
        }
        if (is_null($tollsLocal) || (is_array($tollsLocal) && empty($tollsLocal))) {
            unset($this->TollsLocal);
        } else {
            $this->TollsLocal = $tollsLocal;
        }
        return $this;
    }
    /**
     * Get Tolls value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTolls()
    {
        return isset($this->Tolls) ? $this->Tolls : null;
    }
    /**
     * Set Tolls value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tolls
     * @return \Pcm\StructType\PcmTollDetailReportSummaryLine
     */
    public function setTolls($tolls = null)
    {
        // validation for constraint: string
        if (!is_null($tolls) && !is_string($tolls)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tolls)), __LINE__);
        }
        if (is_null($tolls) || (is_array($tolls) && empty($tolls))) {
            unset($this->Tolls);
        } else {
            $this->Tolls = $tolls;
        }
        return $this;
    }
    /**
     * Get PaymentOption value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPaymentOption()
    {
        return isset($this->PaymentOption) ? $this->PaymentOption : null;
    }
    /**
     * Set PaymentOption value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $paymentOption
     * @return \Pcm\StructType\PcmTollDetailReportSummaryLine
     */
    public function setPaymentOption($paymentOption = null)
    {
        // validation for constraint: string
        if (!is_null($paymentOption) && !is_string($paymentOption)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($paymentOption)), __LINE__);
        }
        if (is_null($paymentOption) || (is_array($paymentOption) && empty($paymentOption))) {
            unset($this->PaymentOption);
        } else {
            $this->PaymentOption = $paymentOption;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pcm\StructType\PcmTollDetailReportSummaryLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
